'PopSymbol.vbs  by gordep
'
'Script to run in the background to dynamically change the Weather Icons used by www.weather.com
'Coding is basically borrowed from Alderaic's start and close script but modified by me.  
'
'Updated 10/24/2003		Included is code to use MarcJ's CleanCloseProcessID.exe.  This must be in your Samurize directory.
'
'Loop looking for change in Symbol
'
' Change the next four lines to your circumstances
'
vInstance = "Symbol"				'Instance name of WeatherSymbol.ini or whatever your config is named
path = "C:\progra~1\Samurize\"             'Your Samurize directory (Should be the same as that in WeatherSymbol.vbs)
vTmp = "Tmp\"					'Set to folder to store temp files (Should be the same as that in WeatherSymbol.vbs).
								'If you don't want to use a temp folder set vTmp = "" (two double quotes with no 
								'space between)
Startup = True						'Set to True if you start your WeatherSymbol.ini with PopSymbol

'#####################################
'#       Change anything after here at your own risk         #
'#####################################
'
Restart = False
vclose = 0
vcount = 0
'GetMyProcessID			'This function gets the ProcessID of wscript instance that is running PopSymbol.vbs
WScript.Echo "PopSymbol Starting "  & vclose

Do While vclose = 0
	Symbol
	WScript.Sleep 360000         'Sleeps for 6 minutes
	vcount = vcount + 1
	If vcount > 239 then                 'Runs for 24 hours
'	If vcount > 10 then                 'Runs for one hour for testing
		vclose = 1
	End If
Loop
WScript.Echo "PopSymbol Ending "  & vclose

'
'Start of Symbol Subroutines
'
Function Symbol				'Check to see if Restore is true from the temp file written by WeatherSymbol.vbs

	spath = path & vTmp & "RestoreSymbol.tmp"
	Set FSys = CreateObject("Scripting.FileSystemObject") 
	If Not (FSys.FileExists(spath)) Then
		Restart = False
		WriteRestoreRec
	End If
	Set f = FSys.OpenTextFile(spath, 1) 
	Restart  = f.readline
	f.close
	If (Not Restart) and (Not Startup)  Then              'If it has changed or PopSymbol has just started 
		Exit Function
	End If
	Restart = False
	Startup = False
	WriteRestoreRec	
	Close						'Close old instance
	Start() 					'Start new instance of weather png
End Function

Function WriteRestoreRec()					'Save Restart switch to RestoreSymbol.tmp
	rpath = path & vTmp & "RestoreSymbol.tmp"
	Set FSys = CreateObject("Scripting.FileSystemObject") 
	Set f = FSys.CreateTextFile(rpath, true) 
	f.writeline(Restart)
	f.close
End Function

Function Start()			'Pop up new weather picture 

	sspath = path & "client " & vInstance
	Set WshShell = CreateObject("wscript.shell")                         
	Set oExec = WshShell.Exec(sspath)                             'Start new Instance of Weather picture
	RecPID(oExec.ProcessID)

End Function

Function RecPID(PID)			'Save ProcessID of new instance

	wpath = path & vTmp & "PID.tmp"
	Set FSys = CreateObject("Scripting.FileSystemObject") 
	Set f = FSys.CreateTextFile(wpath, true) 
	f.writeline(PID)
	f.close

End Function

Function Close()				'Close old instance

	vProcessID = ReadPID                   'Get ProcessID of instance from temp file
	Quote = chr(34)

	Dim WshShell, oExec
	Set WshShell = createobject("wscript.shell")
	Set oExec = WshShell.Exec(path & "CleanCloseProcessID.exe " & vProcessId)

'	strComputer = "."
'	Set objWMIService = GetObject("winmgmts:" _
'	    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
'	Set colProcessList = objWMIService.ExecQuery _
'	    ("Select * from Win32_Process Where ProcessID = " & vProcessID)       	'Is old instance still running
'	For Each objProcess in colProcessList										'If it is						
'		objProcess.Terminate()												'Force close
'	Next

End Function

Function ReadPID()								'Get ProcessID from temp file

	rpath = path & vTmp & "PID.tmp"
	Set FSys = CreateObject("Scripting.FileSystemObject") 
	If Not FSys.FileExists(rpath) Then
		ReadPID = 0
		Exit Function
	End If
	Set f = FSys.OpenTextFile(rpath, 1) 
	ReadPID = f.readline
	f.close

End Function

Function GetMyProcessID							'Get the ProcessId of wscript that is running this script
	GetMyProcessID = GetObject("winmgmts:root\cimv2").Get("Win32_" &_
                             "Process.Handle='" &CreateObject("WScript.Shell")_
                             .Exec("C:\Windows\System32\mshta.exe").ProcessID &"'").ParentProcessId
	wpath = path & vTmp & "PID1.tmp"
	Set FSys = CreateObject("Scripting.FileSystemObject") 
	Set f = FSys.CreateTextFile(wpath, true) 
	f.writeline(GetMyProcessID)
	f.close
End Function

'
' End of Symbol Subroutines
'

